"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createControlledCompilerHost(typescript, parsedCommandLine, system, hostExtensions = []) {
    const baseCompilerHost = typescript.createCompilerHost(parsedCommandLine.options);
    let controlledCompilerHost = Object.assign(Object.assign({}, baseCompilerHost), { fileExists: system.fileExists, readFile: system.readFile, directoryExists: system.directoryExists, getDirectories: system.getDirectories, realpath: system.realpath });
    hostExtensions.forEach((hostExtension) => {
        if (hostExtension.extendCompilerHost) {
            controlledCompilerHost = hostExtension.extendCompilerHost(controlledCompilerHost, parsedCommandLine);
        }
    });
    return controlledCompilerHost;
}
exports.createControlledCompilerHost = createControlledCompilerHost;
